Summary: A Network Intrusion Detection System (NIDS)
Name: firestorm
Version: 0.5.2
Release: 1
License: GPL
Group: System Environment/Daemons
Source: firestorm-%{version}.tar.gz
Buildroot: %{_tmppath}/%{name}-%{version}-root

%description
Firestorm is an extremely high performance network intrusion detection
system (NIDS). At the moment it is just a sensor but plans are to include
real support for analysis, reporting, remote console and on-the-fly
sensor configuration. It is fully pluggable and hence extremely flexible.

%prep
%setup -q
./configure \
	--sysconfdir=/etc \
	--mandir=%_mandir \
	--host=%_target \
	--build=%_build

%build
make

%install
rm -f $RPM_BUILD_ROOT/%_mandir/man1/*
rm -f $RPM_BUILD_ROOT/%_mandir/man5/*
rm -f $RPM_BUILD_ROOT/%_mandir/man8/*
make install DESTDIR=$RPM_BUILD_ROOT

install -d -m 750 $RPM_BUILD_ROOT/etc/init.d
install -m 750 rc.firestorm $RPM_BUILD_ROOT/etc/init.d/firestorm

install -m 640 firestorm.rpm.conf $RPM_BUILD_ROOT/etc/firestorm.conf

# Add user and group before installing
%pre

# old versions used this
userdel firestorm 2>/dev/null || true
groupdel firestorm 2>/dev/null || true

userdel fstorm 2>/dev/null || true
groupdel fstorm 2>/dev/null || true
groupadd -g 303 fstorm || true
useradd -M -s /bin/false -d /var/firestorm -u 303 -g 303 fstorm || true

%post
chkconfig --level 235 firestorm on

%preun
chkconfig --level 235 firestorm del 2>/dev/null || true

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)

# Configuration
%config(noreplace) /etc/firestorm.conf
/etc/init.d/firestorm

# Binaries
%attr(755,root,root) /usr/bin/*

# Documentation
%doc %_mandir/man1/*
%doc %_mandir/man5/*
%doc %_mandir/man8/*
%doc ChangeLog NEWS README INSTALL CREDITS HACKING AUTHORS

# Plugins
%dir /usr/lib/firestorm/
%dir /usr/lib/firestorm/capture
/usr/lib/firestorm/capture/*.so
%dir /usr/lib/firestorm/protocols
/usr/lib/firestorm/protocols/*.so
%dir /usr/lib/firestorm/detection
/usr/lib/firestorm/detection/*.so
%dir /usr/lib/firestorm/output
/usr/lib/firestorm/output/*.so

# Firestorm root dir
%defattr(-,fstorm,fstorm)
%dir /var/firestorm/
%config(noreplace) /var/firestorm/firestorm.rules
/var/firestorm/log
/var/firestorm/snort-rules
