#ifndef __ARGS_HEADER_INCLUDED__
#define __ARGS_HEADER_INCLUDED__

#define AKEY_SIZE 128
#define AVAL_SIZE 2048

#define ARGTYPE_NOP		0
#define ARGTYPE_UINT		1
#define ARGTYPE_PUINT		2
#define ARGTYPE_INT		3
#define ARGTYPE_PINT		4
#define ARGTYPE_BYTES		5
#define ARGTYPE_PBYTES		6
#define ARGTYPE_STRING		7
#define ARGTYPE_BOOL		8
#define ARGTYPE_PBOOL		9
#define ARGTYPE_MAX		10

#define ARGTYPE_LITERAL		ARGTYPE_STRING

struct arg;

typedef int(*arg_cbfn_t)(struct arg *, void *);

struct arg {
	char *name;
	unsigned short type;

	arg_cbfn_t fn;

	union {
		unsigned int v_bytes;
		unsigned int v_uint;
		unsigned int v_bool;
		int v_int;
		char *v_str;
		char *v_literal;
		unsigned int *vp_bytes;
		unsigned int *vp_uint;
		unsigned int *vp_bool;
		int *vp_int;
	}val;
};

typedef int (*proc_args_parse)(struct arg *, char *, void *);

#ifndef __PLUGIN__
int args_parse(struct arg *a, char *str, void *);

/* do not use - for /src/conf.c only */
int arg_found(struct arg *, char *, size_t, char *, size_t, void *);
#endif

#endif /* __ARGS_HEADER_INCLUDED__ */
