#ifndef __TARGET_HEADER_INCLUDED__
#define __TARGET_HEADER_INCLUDED__

typedef int (*proc_target)(struct generator*,
	struct packet *,
	struct alert*,
	void *);
typedef int(*proc_target_validate)(char *, void **);
typedef void(*proc_target_hup)(void *);
typedef void(*proc_target_cleanup)(void *);

#define target_init(a,b,c,d,e) {NULL, a, b, c, d, e}
#define target_null() {NULL, NULL, NULL, NULL, NULL}
struct target {
	struct target		*next;
	const char		*name;
	proc_target		target;
	proc_target_validate	validate;
	proc_target_hup		hup;
	proc_target_cleanup	cleanup;
};

#ifndef __PLUGIN__
void target_stats(void);
struct target *target_find(char *);
int target_add(struct target *);
#endif

typedef int(*proc_target_add)(struct target *);

/* Plugin callback API */
struct target_api {
	size_t size;
	proc_target_add target_add;
	proc_args_parse args_parse;
};
typedef int (*proc_target_load)(struct target_api *);
void target_load(void);

#endif /* __TARGET_HEADER_INCLUDED__ */
